''' <summary>
''' StatusStrip mit eigenem ColorWheelToolStripRenderer
''' </summary>
''' <remarks>eigentlich nur notwendig, um Farbeffekte auch zur Design-Zeit zu sehen</remarks>
Public Class RenderedStatusStrip
    Inherits StatusStrip

    ' Renderer zum Zeichnen des Controls
    Private WithEvents m_Renderer As ColorWheelToolStripRenderer

    Public Sub New()
        MyBase.New()
        ' neuen Renderer erstellen
        m_Renderer = New ColorWheelToolStripRenderer(New ColorWheelProfessionalTable)
        m_Renderer.ControlHue = 0.4R
        MyBase.Renderer = m_Renderer
    End Sub

    ''' <summary>
    ''' gibt den Renderer zum Zeichnen des Controls zurck oder legt diesen fest
    ''' </summary>
    Shadows Property Renderer() As ColorWheelToolStripRenderer
        Get
            Return MyBase.Renderer
        End Get
        Set(ByVal value As ColorWheelToolStripRenderer)
            m_Renderer = value
            MyBase.Renderer = value
            Invalidate()
        End Set
    End Property

    ''' <summary>
    ''' Handler fr das Changed-Event des ToolStripRenderers
    ''' </summary>
    Private Sub m_Renderer_Changed() Handles m_Renderer.Changed
        Invalidate()
    End Sub
End Class
