'Imports System.Collections.ObjectModel
Imports System.Windows.Forms
''' <summary>
''' trgt einen Datei-Typ mit Endung und Icon in der Registry ein
''' </summary>
''' <remarks></remarks>
Public Class Class1
    ' Diese Methode fhrt in Windows Vista nur zum Erfolg, wenn diese Anwendung 
    ' mit Administrator-Rechten gestartet wurde


    Public Shared Sub Main()
        ' CommandLine muss Infos zur Datei enthalten
        Dim txt As String = Environment.CommandLine
        ' In meinem Fall habe ich die Argumente durch "/*/" getrennt
        Dim Idx As Integer = txt.IndexOf("/*/")
        If Idx = -1 Then
            MessageBox.Show("Start ohne Argumente")
            Exit Sub
        Else
            txt = txt.Replace("/*/", "*")
            Dim Teile() As String = txt.Split("*")
            If Teile.Length <> 8 Then
                MessageBox.Show("Anzahl der Argumente stimmt nicht")
                Exit Sub
            Else
                For I As Integer = 1 To Teile.Length - 1
                    Teile(I) = Teile(I).Trim
                Next
                Registrieren(Teile(1), Teile(2), Teile(3), Teile(4), Teile(5), Teile(6), Teile(7))
            End If
        End If

    End Sub
    Private Shared Sub Registrieren(ByVal AppDirectory As String, ByVal AppShortTitle As String, ByVal AppTitle As String, ByVal DocumentName As String, ByVal ExeFileName As String, ByVal IconFileName As String, ByVal Extension As String)
        Try
            ' trgt einen Datei-Typ mit Endung und Icon in der Registry ein
            Dim RK As Microsoft.Win32.RegistryKey
            Dim RK1 As Microsoft.Win32.RegistryKey
            Dim RK2 As Microsoft.Win32.RegistryKey

            ' Eintrag im Classes-Abschnitt der Registry
            RK = Microsoft.Win32.Registry.ClassesRoot
            ' Ein Schlssel mit der Kurzbezeichnung der Anwendung wird angelegt
            RK1 = RK.CreateSubKey(AppShortTitle)
            ' als Wert wird die Bezeichnung fr ein Dokument dieser Anwendung eingetragen
            RK1.SetValue("", AppTitle & " " & DocumentName)
            ' Unterschlssel im Anwendungs-Key fr das Datei-ffnen-Command anlegen
            RK2 = RK1.CreateSubKey("shell\open\command")
            ' Pfad zur Exe der Anwendung, der beim ffnen einer Datei verwendet werden soll, eintragen
            RK2.SetValue("", AppDirectory & "\" & ExeFileName & " %1 /open/")

            If IconFileName <> "" Then
                ' Unterschlssel im Anwendungs-Key fr das Standard-Icon, das fr Dokumente verwendet 
                ' werden soll, anlegen
                RK2 = RK1.CreateSubKey("DefaultIcon")
                ' Pfad zum Icon oder zur Quelle des Icons eintragen
                RK2.SetValue("", AppDirectory & "\" & IconFileName & ",0")
            End If

            ' in der Classes-Root einen neuen Schlssel mit der Dateinamen-Erweiterung fr 
            ' Dokumente anlegen
            RK1 = RK.CreateSubKey(Extension)
            ' als Wert die oben verwandte Anwendungs-Kurzbezeichnung eintragen
            RK1.SetValue("", AppShortTitle)
            ' Fr Test-Zwecke Meldung anzeigen
            MessageBox.Show("Die Verknpfung zum aktuellen Dateityp (" & AppTitle & " " & DocumentName & " - *" & Extension & ") im ClassesRoot der Registry war erfolgreich.")
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

End Class

