Namespace My

    Partial Friend Class MyApplication

        ' Definition fr den verwendeten Datei-Typ
        Private m_Definition As New IconDateiDefinition
        ' Verwaltungsstelle fr Forms und Dateien
        Private m_Manager As Ctls.FormsManager


        ''' <summary>
        ''' Verwaltet Windows Forms und Dateien
        ''' </summary>
        Public ReadOnly Property Manager() As Ctls.FormsManager
            Get
                If m_Manager Is Nothing Then
                    Me.ShutdownStyle = ApplicationServices.ShutdownMode.AfterAllFormsClose
                    m_Manager = New Ctls.FormsManager(m_Definition)
                End If
                Return m_Manager
            End Get
        End Property

        ' Diese Methode wird beim Versuch zum Start einer weiteren Instanz
        ' der Anwendung durchlaufen
        ' Da diese Anwendung (in den Projekt-Eigenschaften eingestellt)
        ' aber eine Einzel-Instanz-Anwendung ist, liefert hier der FormsManager
        ' eine neue Form, die mit .Show angezeigt wird.
        Protected Overrides Sub OnStartupNextInstance(ByVal eventArgs As Microsoft.VisualBasic.ApplicationServices.StartupNextInstanceEventArgs)
            MyBase.OnStartupNextInstance(eventArgs)
            Dim NewForm As Form = CreateNewForm(eventArgs.CommandLine)
            NewForm.Show()
        End Sub
        Protected Overrides Sub OnRun()
            Application.MainForm = CreateNewForm(Me.CommandLineArgs)
            MyBase.OnRun()
        End Sub
        Private Function CreateNewForm(ByVal CommandLine As System.Collections.ObjectModel.ReadOnlyCollection(Of String)) As Form
            Dim frm As Form = m_Definition.CreateForm
            Manager.RegisterForm(frm, CommandLine)
            Return frm
        End Function

    End Class

End Namespace

