''' <summary>
''' Head-Abschnitt einer Icon-Datei. Enthlt als wesentliche Information die 
''' Anzahl im Icon enthaltener Einzelbilder
''' </summary>
''' <remarks></remarks>
Public Class IconHeader

#Region " Private Felder "
    Private m_Reserved As UShort = 0    ' Reserviert, Wert muss 0 sein 
    Private m_Type As UShort = 1        ' Wert muss bei Icon "1" sein (bei Cursor-Datei steht hier "0") 
    Private m_ImageCount As UShort      ' Anzahl im Icon enthaltener Einzelbilder 
#End Region

#Region " Properties "
    ''' <summary>
    ''' Reservierter Wert
    ''' </summary>
    Property Reserved() As UShort
        Get
            Return m_Reserved
        End Get
        Set(ByVal value As UShort)
            m_Reserved = value
        End Set
    End Property

    ''' <summary>
    ''' Typ der Icon-Datei
    ''' </summary>
    ''' <remarks>fr Icon 1, fr Cursor 0</remarks>
    Property Type() As UShort
        Get
            Return m_Type
        End Get
        Set(ByVal value As UShort)
            m_Type = value
        End Set
    End Property

    ''' <summary>
    ''' Anzahl im Icon enthaltener Einzelbilder
    ''' </summary>
    Property ImageCount() As UShort
        Get
            Return m_ImageCount
        End Get
        Set(ByVal value As UShort)
            m_ImageCount = value
        End Set
    End Property
#End Region

#Region " Konstruktoren "
    ''' <summary>
    ''' Konstruktor fr Lesen einer Datei mit BinaryReader
    ''' </summary>
    Public Sub New(ByVal Reader As IO.BinaryReader)
        m_Reserved = Reader.ReadUInt16
        m_Type = Reader.ReadUInt16
        m_ImageCount = Reader.ReadUInt16

        If m_Reserved <> 0 Then Throw New Exception("Ungltige Icon-Datei")
        If m_Type <> 1 Then Throw New Exception("Ungltige Icon-Datei")
    End Sub

    ''' <summary>
    ''' Konstruktor fr fest stehende Anzahl Einzelbilder
    ''' </summary>
    Public Sub New(ByVal ImageCount As Integer)
        m_Reserved = 0
        m_Type = 1
        m_ImageCount = ImageCount
    End Sub
#End Region

#Region " Methoden "
    ''' <summary>
    ''' schreibt den IconHeader mit einem BinaryWriter in einen Straem
    ''' </summary>
    Public Sub Write(ByVal Writer As IO.BinaryWriter)
        Writer.Write(m_Reserved)
        Writer.Write(m_Type)
        Writer.Write(m_ImageCount)
    End Sub
#End Region

End Class
