Imports Ctls
''' <summary>
''' MainForm fr diese Anwendung
''' </summary>
Public Class frm_IconCreator

#Region " Felder "
    ' Icon-Datei
    Private WithEvents m_Datei As IconDatei
    ' Liste mit automatisch selektiertem Item (ist Bestandteil der Datei)
    Private WithEvents m_Images As IconImageList
    ' Referenz zum selektierten IconImage der IconImageList
    Private m_SelectedImage As IconImage = Nothing
    ' Undo-Manager (ist auch in der Dtei zu Hause, hier brauche ich aber seine Events)
    Private WithEvents m_UndoManager As UndoManager
    ' Renderer zum Zeichnen des Controls
    Private WithEvents m_Renderer As ColorWheelToolStripRenderer

    ' globale Liste mit bevorzugten Formaten fr das Neu-Erstellen von IconImages
    Private Shared m_PreferredFormats As List(Of IconImageFormat)

    ' rahmenlose Windows Form zum Anzeigen der Farbauswahl und anderer Optionen
    Private WithEvents m_frm_Options As frm_Options
#End Region

#Region " Konstruktoren "

    Shared Sub New()
        ' globale Liste mit bevorzugten Formaten fr das Neu-Erstellen von IconImages auffllen
        m_PreferredFormats = New List(Of IconImageFormat)
        m_PreferredFormats.Add(New IconImageFormat(256, 256, 32, True))
        m_PreferredFormats.Add(New IconImageFormat(48, 48, 32, False))
        m_PreferredFormats.Add(New IconImageFormat(48, 48, 8, False))
        m_PreferredFormats.Add(New IconImageFormat(48, 48, 4, False))

        m_PreferredFormats.Add(New IconImageFormat(32, 32, 32, False))
        m_PreferredFormats.Add(New IconImageFormat(32, 32, 8, False))
        m_PreferredFormats.Add(New IconImageFormat(32, 32, 4, False))

        m_PreferredFormats.Add(New IconImageFormat(16, 16, 32, False))
        m_PreferredFormats.Add(New IconImageFormat(16, 16, 8, False))
        m_PreferredFormats.Add(New IconImageFormat(16, 16, 4, False))
    End Sub

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Neuen ColorWheelToolStripRenderer erstellen 
        m_Renderer = New ColorWheelToolStripRenderer(New ColorWheelProfessionalTable)
        ' Farb-Einstellungen fr diesen Renderer aus Settings bernehmen
        m_Renderer.SetHueAndStretchFactor(My.Settings.RendererHue, My.Settings.RendererStretch)
        ' Referenz des ColorWheelToolStripRenderer auf alle Controls, 
        ' die damit gerendert werden knnen, bertragen
        Me.RenderedToolStrip1.Renderer = m_Renderer
        Me.BitmapPainter1.Renderer = m_Renderer
        Me.RenderedToolStrip2.Renderer = m_Renderer
        Me.RenderedStatusStrip1.Renderer = m_Renderer
        Me.IconListControl1.Renderer = m_Renderer

    End Sub
#End Region

#Region " Methoden "

    ''' <summary>
    ''' Handler fr Klick auf "Datei Neu"
    ''' </summary>
    Private Sub NeuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeuToolStripMenuItem.Click
        My.Application.Manager.Create_New()
    End Sub

    ''' <summary>
    ''' Handler fr Klick auf "Datei ffnen"
    ''' </summary>
    Private Sub ffnenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ffnenToolStripMenuItem.Click
        My.Application.Manager.Open_Dialog()
    End Sub
    ''' <summary>
    ''' Handler fr Klick auf "Datei Speichern"
    ''' </summary>
    Private Sub SpeichernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernToolStripMenuItem.Click
        My.Application.Manager.Save()
    End Sub
    ''' <summary>
    ''' Handler fr Klick auf "Datei Speichern unter"
    ''' </summary>
    Private Sub SpeichernunterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernunterToolStripMenuItem.Click
        My.Application.Manager.Save_As()
    End Sub
    ''' <summary>
    ''' Handler fr Klick auf "Datei Schlieen"
    ''' </summary>
    Private Sub SchlieenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SchlieenToolStripMenuItem.Click
        Me.Close()
    End Sub
    ''' <summary>
    ''' Handler fr Klick auf "Datei Alles Beenden"
    ''' </summary>
    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        My.Application.Manager.CloseAllForms()
    End Sub
    ''' <summary>
    ''' Handler fr Klick auf "Datei Auto Icon neu"
    ''' </summary>
    Private Sub AutoIconNeuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AutoIconNeuToolStripMenuItem.Click
        Dim Dlg As New OpenFileDialog
        Dlg.Title = "Auto-Icon erstellen"
        Dlg.Filter = "Bilddateien|*.png; *.bmp; *.gif; *.jpg"
        Dlg.FilterIndex = 1
        Dlg.Multiselect = False
        If Dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            Try
                Dim Img As Image = Image.FromFile(Dlg.FileName)
                Img.Dispose()
                m_Datei.RunCreateAutoIcon(Dlg.FileName)
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If
    End Sub

    ''' <summary>
    ''' wenn sich nach Speichern der Datei der Anzeige-Text fr das aktuelle Fenster ndert
    ''' </summary>
    Private Sub m_Datei_FormText_Changed() Handles m_Datei.FormText_Changed
        ' wird der Anzeige-Text fr dieses Fenster aktualisiert
        Me.Text = My.Application.Manager.AnwendungsTitel & " - " & m_Datei.FormText
    End Sub

    ''' <summary>
    ''' beim Laden der Form wird diese im FormsManager registriert und die dazu gehrende
    ''' Datei durch den FormsManager zur Verfgung gestellt.
    ''' </summary>
    Private Sub frm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Referenz zur zu dieser Windows Form gehrenden Datei holen
        m_Datei = My.Application.Manager.GetFile(Me)
        ' Referenz zur Bild-Liste
        m_Images = m_Datei.Images
        ' Referenz zum Undo-Manager
        m_UndoManager = m_Datei.UndoManager
        ' Fenstext
        Me.Text = My.Application.Manager.AnwendungsTitel & " - " & m_Datei.FormText
        ' Die Items-Auflistung im List-Control ist an die IconImageList der Icon-Datei angepasst
        ' zur Erklrung: Die IconImageList sorgt automatisch dafr, dass immer ein enthaltenes Item 
        ' SelectedItem ist und liefert Events fr nderung sowohl der Liste als auch von SelectedItem
        Me.IconListControl1.Items = m_Images
        ' mit SetSelectedImage werden von SelectedItem abhngige Controls aktiviert, deaktiviert
        ' oder notwendige Properties gesetzt
        SetSelectedImage(m_Images.SelectedItem)
    End Sub

    ''' <summary>
    ''' Handler fr das SelectedItemChanged- und Changed- Event der IconImageList
    ''' </summary>
    Private Sub m_Images_SelectedItemChanged() Handles m_Images.SelectedItemChanged, m_Images.Changed
        SetSelectedImage(m_Images.SelectedItem)
    End Sub

    ''' <summary>
    ''' interne Methode zum Anzeigen eines SelectedItem der IconImageList
    ''' </summary>
    Private Sub SetSelectedImage(ByVal NewSelectedImage As IconImage)
        If m_SelectedImage IsNot NewSelectedImage Then
            ' nur wenn wirklich ein neues Item selektiert wurde...
            m_SelectedImage = NewSelectedImage
        Else
            ' keine nderung, also nichts weiter zu tun
            Exit Sub
        End If

        If m_SelectedImage Is Nothing Then
            ' wenn SelectedImage leer ist, es also kein SelectedImage gibt
            Me.BildLschenToolStripMenuItem.Enabled = False
            Me.ToolStripButtonRemoveImage.Enabled = False
            Me.BildExportierenToolStripMenuItem.Enabled = False
            Me.BitmapPainter1.Bitmap = Nothing
            Me.ToolStripStatusLabel1.Text = ""
        Else
            ' SelectedImage
            Me.BildLschenToolStripMenuItem.Enabled = True
            Me.ToolStripButtonRemoveImage.Enabled = True
            Me.BildExportierenToolStripMenuItem.Enabled = True

            Me.BitmapPainter1.Bitmap = m_SelectedImage.Bitmap
            Me.ToolStripStatusLabel1.Text = m_SelectedImage.ToString.Replace(vbCrLf, " - ")
        End If
    End Sub

    ''' <summary>
    ''' Handler fr Click-Event fr "Neues Bild"-Toolstrip-Buttons
    ''' </summary>
    Private Sub AddImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonAddImage.Click, NeuesBildToolStripMenuItem.Click

        ' nchstes bevorzugt zu erstellendes IconImage-Format ermitteln
        Dim NextFmt As IconImageFormat = GetNextPreferredFormat(m_Images)

        ' Form zur Auswahl des neuen IconImage-Formats anzeigen
        Dim frm As New frm_NewLayer(NextFmt, m_Images, m_Renderer.ControlBackColor)

        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            ' wenn diese Form mit OK geschlossen wurde,
            If frm.AktuellesBildAlsGrundlage Then
                ' und das aktuell selektierte IconImage als Grundlage fr ein neues
                ' IconImage dienen soll, entsprechendes Undo-Redo-Command der Datei erstellen und ausfhren
                m_Datei.RunCreateNew(frm.ResultFormat, "")
            Else
                ' Wenn "AktuellesBildAlsGrundlage" in frm_NewLayer nicht ausgewhlt wurde, 
                ' Dialog zum auswhlen einer Bilddatei anzeigen
                Dim Dlg As New OpenFileDialog
                Dlg.Title = "Bild importieren"
                Dlg.Filter = "Bilddateien|*.png; *.bmp; *.gif; *.jpg"
                Dlg.FilterIndex = 1
                Dlg.Multiselect = False
                If Dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
                    ' Wenn dieser Dialog mit OK geschlossen wurde,
                    ' entsprechendes Undo-Redo-Command der Datei (neues IconImage 
                    ' auf Grundlage einer vorhandenen Bilddatei) erstellen und ausfhren
                    Try
                        m_Datei.RunCreateNew(frm.ResultFormat, Dlg.FileName)
                    Catch ex As Exception
                        MessageBox.Show(ex.Message)
                    End Try
                End If
            End If
        End If
    End Sub

    ''' <summary>
    ''' liefert das nchste bevorzugte Bildformat vor dem Hinzufgen von IconImages zum Icon
    ''' </summary>
    Private Function GetNextPreferredFormat(ByVal Images As IconImageList) As IconImageFormat
        ' wenn keine IconImages in der Liste enthalten, 48x48 32BPP mit Transparenz
        If Images.Count = 0 Then Return m_PreferredFormats(1)

        ' Wenn IconImages in der Liste enthalten sind, ist auch eines selektiert.
        ' Dann zunchst das nchstkleinere Format in der Bevorzugt-Liste suchen
        Dim FoundPosition As Integer = -1
        Dim SelectedFormat As IconImageFormat = CType(Images.SelectedItem, IconImageFormat)
        ' zunchst die Position des aktuell selektierten Icon-Bildformats in der Bevorzugt-Liste
        ' suchen
        For Each Fmt As IconImageFormat In m_PreferredFormats
            If Fmt.CompareTo(SelectedFormat) = 0 Then
                FoundPosition = m_PreferredFormats.IndexOf(Fmt)
                Exit For
            End If
        Next

        ' wenn also das Format des aktuellen Items in der Bevorzugt-Liste enthalten ist, 
        ' und dises Format in der Bevorzugt-Liste nicht das letzte ist, 
        If FoundPosition > -1 AndAlso FoundPosition < m_PreferredFormats.Count - 1 Then
            ' nachsehen, ob es in der Bevorzugt-Liste ein kleineres Format gibt, 
            ' das im aktuellen Icon noch nicht enthalten ist.
            For I As Integer = FoundPosition + 1 To m_PreferredFormats.Count - 1
                Dim WasFound As Boolean = False
                For Each Img As IconImage In Images
                    If Img.CompareTo(m_PreferredFormats(I)) = 0 Then
                        WasFound = True
                        Exit For
                    End If
                Next
                If Not WasFound Then
                    ' Format zurckgeben
                    Return m_PreferredFormats(I)
                End If
            Next
        End If
        ' an dieser Stelle steht fest, dass kein geeignetes kleineres Format gefunden werden konnte,
        ' nun alle Formate der Bevorzugt-Liste durchgehen und wenn hier eines vorhanden ist, das 
        ' nicht im Icon enthalten ist, dieses zurck geben
        For Each Fmt As IconImageFormat In m_PreferredFormats
            Dim WasFound As Boolean = False
            For Each Img As IconImage In Images
                If Img.CompareTo(Fmt) = 0 Then
                    WasFound = True
                    Exit For
                End If
            Next
            If Not WasFound Then
                ' Format zurckgeben
                Return Fmt
            End If
        Next


        ' wenn nichts geeignetes gefunden werden konnte, wird trotzdem ein Format zurck gegeben
        Return m_PreferredFormats(1)
    End Function

    ''' <summary>
    ''' Handler fr Klick auf ein "Bild entfernen"-ToolStripItem
    ''' </summary>
    Private Sub RemoveIconImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonRemoveImage.Click, BildLschenToolStripMenuItem.Click
        m_Datei.RunRemove()
    End Sub

    ''' <summary>
    ''' Handler fr das StateChanged-Event des UndoManagers
    ''' </summary>
    Private Sub m_UndoManager_StateChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_UndoManager.StateChanged
        ' Rckgangig- und Wiederholen-Button aktivieren bzw. deaktivieren
        Me.ToolStripButtonUndo.Enabled = m_UndoManager.CanUndo
        Me.ToolStripButtonRedo.Enabled = m_UndoManager.CanRedo

        ' Text fr Rckgangig- und Wiederholen-Button (nur fr ToolTip) aktualisieren
        Dim UndoText As String = "&Rckgngig "
        Dim RedoText As String = "&Wiederholen "

        Dim cmd As Command = m_UndoManager.Peek()
        If cmd IsNot Nothing Then UndoText &= cmd.Name
        Me.ToolStripButtonUndo.Text = UndoText.Substring(1)

        cmd = m_UndoManager.Current
        If cmd IsNot Nothing Then RedoText &= cmd.Name
        Me.ToolStripButtonRedo.Text = RedoText.Substring(1)
    End Sub

    ''' <summary>
    ''' Handler fr Klick auf Undo-ToolStripButton
    ''' </summary>
    Private Sub ToolStripButtonUndo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonUndo.Click
        m_UndoManager.Undo()
    End Sub

    ''' <summary>
    ''' Handler fr Klick auf Redo-ToolStripButton
    ''' </summary>
    Private Sub ToolStripButtonRedo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonRedo.Click
        m_UndoManager.Redo()
    End Sub

    ''' <summary>
    ''' Handler fr Klick auf "Bild exportieren"-ToolStripButton
    ''' </summary>
    Private Sub BildExportierenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BildExportierenToolStripMenuItem.Click
        ' hier biete ich nur das PNG-Format an
        Dim Dlg As New SaveFileDialog
        Dlg.Title = "Bild exportieren"
        Dlg.Filter = "PNG-Dateien (*.png)|*.png"
        Dlg.FilterIndex = 1
        Dlg.AddExtension = True
        Dlg.OverwritePrompt = True
        If Dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            Try
                m_Images.SelectedItem.Bitmap.Save(Dlg.FileName, Imaging.ImageFormat.Png)
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If
    End Sub

    ''' <summary>
    ''' zeigt eine rahmenlose Windows Form zur Farbauswahl und Auswahl anderer Optionen an
    ''' </summary>
    Private Sub ToolStripButtonHintergrundfarbe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonHintergrundfarbe.Click

        ' wenn bereits eine Instanz der Form angezeigt wird, ist nichts zu tun
        If m_frm_Options IsNot Nothing Then Exit Sub

        ' neue Windows Form zur Farbauswahl mit aktuellem Renderer instanziieren
        m_frm_Options = New frm_Options(m_Renderer)
        ' Startposition der Windows Form am Platz des ToolStripButtons festlegen
        m_frm_Options.StartPosition = FormStartPosition.Manual
        m_frm_Options.Location = Me.PointToScreen(New Point(Me.ToolStripButtonHintergrundfarbe.Bounds.X, Me.ToolStripButtonHintergrundfarbe.Bounds.Bottom))
        ' Farbauswahl-Form anzeigen
        m_frm_Options.Show()
        m_frm_Options.Focus()
    End Sub

    ''' <summary>
    ''' wenn die Farbauswahl-Form den Focus verliert, wird diese geschlossen
    ''' </summary>
    Private Sub m_frm_Options_Deactivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_frm_Options.Deactivate
        If Not m_frm_Options.ColorDialogActive Then
            m_frm_Options.Close()
        End If

    End Sub

    ''' <summary>
    ''' wenn die Farbauswahl-Form geschlossen wird, 
    ''' </summary>
    Private Sub m_frm_Colors_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles m_frm_Options.FormClosing
        ' in der Form ausgewhlte Optionen in Settings speichern
        My.Settings.RendererStretch = m_Renderer.StretchFactor
        My.Settings.RendererHue = m_Renderer.ControlHue
        ' Referenz zur Form auf Nothing setzen
        m_frm_Options = Nothing
    End Sub

    ' erstellt die Items im Fenster-Menu neu
    Private Sub ToolStripDropDownButtonFenster_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripDropDownButtonFenster.DropDownOpening
        ' nach DropDown im Fenster-Menu werden Items mit Beschriftung und Referenz zu
        ' allen offenen Datei-Forms in dieses Men neu eingefgt
        Dim menu As ToolStripDropDownButton = CType(sender, ToolStripDropDownButton)

        ' Das aktuelle Fenster-Men zunchst bereinigen
        If menu.DropDownItems.Count > 0 Then
            For Each item As ToolStripMenuItem In menu.DropDownItems
                RemoveHandler item.Click, AddressOf FensterMenuItem_Click
            Next
            menu.DropDownItems.Clear()
        End If

        Dim AnwendungsTitel As String = My.Application.Manager.AnwendungsTitel
        Dim TitelLaenge As Integer = AnwendungsTitel.Length + 3

        ' Dieses Men erhlt je ein Item fr jede offene DateiForm
        For Each frm As Form In My.Application.Manager.OpenForms
            Dim item As New ToolStripMenuItem
            item.Text = frm.Text.Substring(TitelLaenge)
            item.Tag = frm
            If frm Is Me Then item.Checked = True
            menu.DropDownItems.Add(item)
            ' einen Handler fr das Click-Ereignis fr dieses Item hinzu fgen
            AddHandler item.Click, AddressOf FensterMenuItem_Click
        Next
    End Sub

    ''' <summary>
    ''' Eventhandler fr das Click-Ereignis auf ein Item im Fenster-Menue einer DateiForm
    ''' </summary>
    Private Sub FensterMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        ' ausgewhlte Form aktivieren
        CType(CType(sender, ToolStripMenuItem).Tag, Form).Activate()
    End Sub
#End Region

End Class