Imports Ctls
''' <summary>
''' Optionen-Dialog fr die IconCreator-Anwendung
''' </summary>
Public Class frm_Options

#Region " Felder "
    ' Flag, whrend der Initialisierung True
    Private m_Init As Boolean = True

    ' verwendeter Renderer 
    Private WithEvents m_Renderer As ColorWheelToolStripRenderer

    ' Eine extra Klasse, die eine Bitmap fr den Transparenz-Basisfarbe-Button liefert
    ' (fr transparente Farbe wird hier ein grau-weisses Raster angezeigt)
    Private m_GifBackColorColorBitmapCreator As GifBackColorColorBitmapCreator

    ' diese rahmen- und parentlose Form soll normalerweise geschlossen werden, wenn 
    ' sie den Focus verliert. Ein Focusverlust tritt allerdings auch ein,
    ' wenn von dieser Form aus eine neue Windows Form oder ein Dialog geffnet wird.
    ' Damit in diesem Fall das Schlieen dieser Form verhindert wird, wird 
    ' solange ein "Child-Dialog" geffnet ist, ColorDialogActive auf True gesetzt
    Public ColorDialogActive As Boolean = False
#End Region

#Region " Konstruktoren "

    ''' <summary>
    ''' Konstruktor fr eine Instanz der Windows Form mit fest stehendem Renderer
    ''' </summary>
    Public Sub New(ByVal Renderer As ColorWheelToolStripRenderer)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

        ' Referenz zur bergebenen Renderer-Instanz
        m_Renderer = Renderer

        ' Referenz zur Farbtabelle, aktuellen Hue-Wert und Dehnungsfaktor an das 
        ' Control zur Farbauswahl bergeben
        Me.ColorWheelProfessionalTableControl1.Table = m_Renderer.BaseTable
        Me.ColorWheelProfessionalTableControl1.StretchFactor = m_Renderer.StretchFactor
        Me.ColorWheelProfessionalTableControl1.Hue = m_Renderer.ControlHue
        m_GifBackColorColorBitmapCreator = New GifBackColorColorBitmapCreator(My.Settings.GifBackColor, m_Renderer.SeparatorDarkPen)
        Me.ButtonGifBackColor.Image = m_GifBackColorColorBitmapCreator.Bitmap
        If My.Settings.GifBackColor.A = 0 Then
            Me.CheckBoxTransparent.Checked = True
        End If
        m_Init = False

        ' eigene Hintergrundfarbe festlegen
        Me.BackColor = m_Renderer.ControlBackColor

        ' DoubleBuffering aktivieren
        Me.SetStyle(ControlStyles.DoubleBuffer Or ControlStyles.UserPaint _
         Or ControlStyles.AllPaintingInWmPaint, True)

        ' Umweg ber eine ImageList, um eine Bitmap transparent zu machen
        Dim IL As New ImageList
        IL.ImageSize = New Size(16, 16)
        IL.ColorDepth = ColorDepth.Depth32Bit
        IL.Images.Add(My.Resources.install)
        IL.TransparentColor = Color.Magenta
        Me.ButtonRegister.Image = IL.Images(0)

    End Sub

#End Region

#Region " Methoden "

    ' Handler fr das Changed-Event des Renderers
    Private Sub m_Renderer_Changed() Handles m_Renderer.Changed
        ' Hintergrundfarbe der Windows Form ndern
        Me.BackColor = m_Renderer.ControlBackColor
        m_GifBackColorColorBitmapCreator.BorderPen = m_Renderer.SeparatorDarkPen
        ' Bitmap fr ButtonGifBackColor anpassen
        Me.ButtonGifBackColor.Image = m_GifBackColorColorBitmapCreator.Bitmap
    End Sub

    ''' <summary>
    ''' berschreiben der OnPaintBackground-Methode der Windows Form
    ''' </summary>
    Protected Overrides Sub OnPaintBackground(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaintBackground(e)
        Dim g As Graphics = e.Graphics
        ' Hier wird ein eigener 3D-Rahmen mit Pens, die der 
        ' ColorWheelToolStripRenderer zur Verfgung stellt, gezeichnet
        g.DrawLine(m_Renderer.SeparatorLightPen, 0, 0, Me.Width - 1, 0)
        g.DrawLine(m_Renderer.SeparatorDarkPen, 0, Me.Height - 1, Me.Width - 1, Me.Height - 1)
        g.DrawLine(m_Renderer.SeparatorDarkPen, 0, 192, Me.Width - 1, 192)
        g.DrawLine(m_Renderer.SeparatorLightPen, 0, 193, Me.Width - 1, 193)

        g.DrawLine(m_Renderer.SeparatorDarkPen, 0, 242, Me.Width - 1, 242)
        g.DrawLine(m_Renderer.SeparatorLightPen, 0, 243, Me.Width - 1, 243)

        g.DrawLine(m_Renderer.SeparatorLightPen, 0, 0, 0, Me.Height - 1)
        g.DrawLine(m_Renderer.SeparatorDarkPen, Me.Width - 1, 0, Me.Width - 1, Me.Height - 1)
    End Sub

    ''' <summary>
    ''' Handler fr das Changed-Event des Farbauswahl-Controls
    ''' </summary>
    Private Sub ColorWheelProfessionalTableControl1_Changed() Handles ColorWheelProfessionalTableControl1.Changed
        ' nach nderung der Farbauswahl Werte fr Hue und Dehnungsfaktor im eigenen Renderer bernehmen
        m_Renderer.SetHueAndStretchFactor(ColorWheelProfessionalTableControl1.Hue, ColorWheelProfessionalTableControl1.StretchFactor)
    End Sub

    ''' <summary>
    ''' Handler fr das Click-Event fr ButtonGifBackColor
    ''' </summary>
    Private Sub ButtonGifBackColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGifBackColor.Click
        ' Auswhlen einer neuen Transparenz-Reduktions-Basisfarbe
        Dim dlg As New ColorDialog
        ' Flag zum Verhindern des Schlieens dieser Form bei Focus-Verlust auf True setzen 
        ColorDialogActive = True
        If dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            ' Wenn der Farbauswahl-Dialog mit Result OK geschlossen wurde,
            ' neue Transparenz-Hintergrundfarbe in Settings und abhngigen 
            ' Controls bekannt machen
            My.Settings.GifBackColor = dlg.Color
            m_GifBackColorColorBitmapCreator.Color = dlg.Color
            Me.ButtonGifBackColor.Image = m_GifBackColorColorBitmapCreator.Bitmap
            Me.CheckBoxTransparent.Checked = False
        End If
        ' Flag zurck setzen
        ColorDialogActive = False
    End Sub

    ''' <summary>
    ''' Handler fr das CheckedChanged-Event von CheckBoxTransparent 
    ''' </summary>
    Private Sub CheckBoxTransparent_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxTransparent.CheckedChanged
        If ColorDialogActive OrElse m_Init Then Exit Sub

        If CheckBoxTransparent.Checked Then
            ' Wenn diese CheckBox neu gecheckt wird, Color.Transparent als 
            ' neue Transparenz-Hintergrundfarbe in Settings und abhngigen 
            ' Controls bekannt machen
            My.Settings.GifBackColor = Color.Transparent
            m_GifBackColorColorBitmapCreator.Color = Color.Transparent
            Me.ButtonGifBackColor.Image = m_GifBackColorColorBitmapCreator.Bitmap
        Else
            ' ansonsten ohne nderungen in Settings einen grauen Farbton fr die
            ' Transparenz-Hintergrundfarbe verwenden
            My.Settings.GifBackColor = Color.LightGray
            m_GifBackColorColorBitmapCreator.Color = Color.LightGray
            Me.ButtonGifBackColor.Image = m_GifBackColorColorBitmapCreator.Bitmap
        End If
    End Sub

    Private Sub ButtonRegister_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRegister.Click
        ' Dieser Button erscheint hier nur zur Demonstration.
        ' Das Setzen von anwendungsspezifischen Registry-Einstellungen sollte 
        ' im Setup-Projekt erfolgen
        ColorDialogActive = True
        ' Vorwarnung als MessageBox abgeben
        Dim msg As String = "Folgend wird der Dialog der Benutzerkontensteuerung zum Zugriff auf die Registry geffnet. " & _
        "Erst nach Besttigung durch den Benutzer wird der aktuelle Datei-Typ in der Registry vermerkt."
        If MessageBox.Show(msg, Application.ProductName, MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) = Windows.Forms.DialogResult.OK Then
            ' Code zum Registry-Zugriff
            My.Application.Manager.RegisterFileType(Application.StartupPath)
        End If
        ColorDialogActive = False
    End Sub
#End Region

End Class